#include <vector>
#include <iostream>
#include <string>
using namespace std;
int main()
{
    const size_t SCREEN_WIDTH = 80;
    const size_t MAX_ASTERISK = SCREEN_WIDTH - 3 - 1;
    size_t number_count, bin_count, i, j;
    cerr << "Enter number count: ";
    cin >> number_count;
    vector<double> numbers(number_count);
    cerr << "Enter numbers: ";
    for (i = 0; i < number_count; i++) cin >> numbers[i];
    cerr << "Enter bin count: ";
    cin >> bin_count;
    vector<size_t> bins(bin_count);

    double min = numbers[0];
    double max = numbers[0];
    for (double x : numbers) {
        if (x < min) {
            min = x;
        }
        else if (x > max) {
                max = x;
        }
    }

    double bin_size = (max - min) / bin_count;

    for (i = 0; i < number_count; i++) {
            bool found = false;
            for (j = 0; (j < bin_count - 1) && !found; j++) {
                auto lo = min + j * bin_size;
                auto hi = min + (j + 1) * bin_size;
                if ((lo <= numbers[i]) && (numbers[i] < hi)) {
                    bins[j]++;
                    found = true;
                }
            }
            if (!found) {
                bins[bin_count - 1]++;
            }
    }
    double max_count = bins[0];
    for (double x: bins){
        if (x > max_count) {
            max_count = x;
        }
    }
    size_t sum_height = 0;
    for (i=0; i<bin_count ; i++){
        double count = bins[i];
        size_t height = MAX_ASTERISK * (static_cast<double>(count) / max_count);
        sum_height = sum_height + height;
    }
    size_t av_height=sum_height/bin_count;

    for (i=0; i<bin_count; i++){
        if (bins[i]<100){
            cout << ' ';
        }
        if (bins[i]<10){
           cout << ' ';
        }
        double count = bins[i];
        size_t height = MAX_ASTERISK * (static_cast<double>(count) / max_count);
        if (height < av_height){
           string lineAd (av_height - height , '-');
           string line (height , '*');
           cout << bins[i] << "|" << line << lineAd << endl;
        }
        if (height > av_height){
           string lineAd (height - av_height , '+');
           string line (av_height , '*');
           cout << bins[i] << "|" << line << lineAd << endl;
        }
        if (height == av_height){
        string line (height , '*');
        cout << bins[i] << "|" << line << endl;
        }
    }
    return 0;
}
